<?php

define("IPB_PREFIX", "dle");

$ipb = new ipb;

class ipb {

	var $ipb_dbconfig_host			= "localhost";
	var $ipb_dbconfig_database		= "ipb";
	var $ipb_dbconfig_username		= "root";
	var $ipb_dbconfig_password		= "";

/*
  !
*/
	function from_dle_logout($member_name) {
		global $db;

		$this_time = time();

		$db->connect($this->ipb_dbconfig_username, $this->ipb_dbconfig_password, $this->ipb_dbconfig_database, $this->ipb_dbconfig_host);

		$db->query("UPDATE ibf_sessions SET member_name = '', member_id = '0', login_type = '0' WHERE member_name = '$member_name'");
		$db->query("UPDATE ibf_members SET last_visit = '$this_time', last_activity = '$this_time'");

		$db->connect(DBUSER, DBPASS, DBNAME, DBHOST);

		setcookie('pass_hash' , '-1');
		setcookie('member_id' , '-1');
		setcookie('session_id', '-1');
		setcookie('topicsread', '-1');
		setcookie('anonlogin' , '-1');
		setcookie('forum_read', '-1');
	}


	function from_dle_login($member_id) {
		global $db;

		$member_email    = $member_id['email'];
		$member_name     = $member_id['name'];
		$member_password = $member_id['password'];

		$db->connect($this->ipb_dbconfig_username, $this->ipb_dbconfig_password, $this->ipb_dbconfig_database, $this->ipb_dbconfig_host);

		$result = $db->query("SELECT * FROM ibf_members_converge WHERE converge_email = '$member_email'");

		$row = $db->get_row($result);
		$converge_pass_salt = $row['converge_pass_salt'];
		$converge_id = $row['converge_id'];

		$converge_pass_hash = md5(md5($converge_pass_salt) . $member_password);

		$result = $db->query("SELECT member_login_key FROM ibf_members WHERE id = '$converge_id'");
		$row = $db->get_row($result);
		$member_login_key = $row['member_login_key'];

		$result2 = $db->query("SELECT mgroup FROM ibf_members WHERE id = '$converge_id'");
		$row2 = $db->get_row($result2);
		$member_group = $row2['mgroup'];

		$session_id = md5( uniqid(microtime()) );
		$user_ip    = $this->user_ip();
		$user_agent = $this->user_agent();

		$result = $db->query("INSERT INTO ibf_sessions (id, member_name, member_id, running_time, ip_address, browser, login_type, member_group) VALUES ('$session_id', '$member_name', '$converge_id', '".time()."', '$user_ip', '$user_agent', '0', '$member_group')");

		setcookie("member_id",  $converge_id);
		setcookie("pass_hash",  $member_login_key);
		setcookie("session_id", $session_id);

		$db->connect(DBUSER, DBPASS, DBNAME, DBHOST);
	}


	function from_dle_registration($member_info)
	{
		global $db;

		$db->connect($this->ipb_dbconfig_username, $this->ipb_dbconfig_password, $this->ipb_dbconfig_database, $this->ipb_dbconfig_host);

		$this_time = time();

		$user_ip		= $this->user_ip();
		$salt			= $this->generate_password_salt(5);
		$salt = str_replace( '\\', "\\\\", $salt );
		$passhash		= $this->generate_compiled_passhash($salt, $member_info['password']);
		$member_login_key	= $this->generate_auto_log_in_key();

		$db->query("INSERT INTO ibf_members_converge (converge_email, converge_pass_hash, converge_pass_salt, converge_joined) VALUES ('$member_info[email]', '$passhash', '$salt', '$this_time')");

		$result = $db->query("SELECT converge_id FROM ibf_members_converge WHERE converge_email = '$member_info[email]'");
		$row = $db->get_row($result);
		$member_id = $row['converge_id'];

		$db->query("INSERT INTO ibf_members (id, name, member_login_key, email, mgroup, joined, last_visit, last_activity, allow_admin_mails, time_offset, hide_email, email_pm, language, ip_address, members_display_name, members_l_display_name, members_l_username) VALUES ('$member_id', '$member_info[name]', '$member_login_key', '$member_info[email]', '3', '$member_info[regtime]', '$member_info[regtime]', '$member_info[regtime]', '0', '0', '1', '1', 'en', '$user_ip', '$member_info[name]','strtolower($member_info[name])','$member_info[name]')");
		$db->query("INSERT INTO ibf_member_extra (id) VALUES ('$member_id')");
		$db->connect(DBUSER, DBPASS, DBNAME, DBHOST);
	}


	function from_dle_dopinfo($member_dopinfo)
	{
		global $db;

		$db->connect($this->ipb_dbconfig_username, $this->ipb_dbconfig_password, $this->ipb_dbconfig_database, $this->ipb_dbconfig_host);
		$this_time = time();

		$user_ip			= $this->user_ip();
		$salt			= $this->generate_password_salt();
		$passhash		= $this->generate_compiled_passhash($salt, $member_dopinfo['password']);
		$member_login_key	= $this->generate_auto_log_in_key();

		$result = $db->query("SELECT id FROM ibf_members WHERE name = '$member_dopinfo[name]'");
		$row = $db->get_row($result);
		$member_idinfo = $row['id'];

		$db->query("UPDATE ibf_member_extra set icq_number='$member_dopinfo[icq]', interests='$member_dopinfo[info]', location='$member_dopinfo[land]' where id='$member_idinfo'");
		$db->connect(DBUSER, DBPASS, DBNAME, DBHOST);
	}


	function from_dle_profile1( $member_profile1 )
	{
		global $db;

		$db->connect($this->ipb_dbconfig_username, $this->ipb_dbconfig_password, $this->ipb_dbconfig_database, $this->ipb_dbconfig_host);
		$this_time = time();

		$user_ip			= $this->user_ip();
		$salt				= $this->generate_password_salt();
		$passhash			= $this->generate_compiled_passhash($salt, $member_profile1['password']);
		$member_login_key	= $this->generate_auto_log_in_key();

		$result = $db->query("SELECT id FROM ibf_members WHERE name = '$member_profile1[name]'");
		$row = $db->get_row($result);
		$member_idprof1 = $row['id'];

		$db->query("UPDATE ibf_member_extra set signature='$member_profile1[signature]', location='$member_profile1[land]', icq_number='$member_profile1[icq]', interests='$member_profile1[info]' where id='$member_idprof1'");
		$db->query("UPDATE ibf_members set email='$member_profile1[email]' where id='$member_idprof1'");
		$db->query("UPDATE ibf_members_converge set converge_email='$member_profile1[email]', converge_pass_hash='$passhash', converge_pass_salt='$salt' where converge_id='$member_idprof1'");

		$db->connect(DBUSER, DBPASS, DBNAME, DBHOST);
	}

	//----------------------------------------------------------------------------------------------------
	function from_dle_profile2($member_profile2)
	{
		global $db;

		$db->connect($this->ipb_dbconfig_username, $this->ipb_dbconfig_password, $this->ipb_dbconfig_database, $this->ipb_dbconfig_host);
		$this_time = time();

		$user_ip			= $this->user_ip();
		$salt			= $this->generate_password_salt();
		$passhash		= $this->generate_compiled_passhash($salt, $member_profile2['password']);
		$member_login_key	= $this->generate_auto_log_in_key();

		$result = $db->query("SELECT id FROM ibf_members WHERE name = '$member_profile2[name]'");
		$row = $db->get_row($result);
		$member_idprof2 = $row['id'];

		$db->query("UPDATE ibf_member_extra set signature='$member_profile2[signature]', location='$member_profile2[land]', icq_number='$member_profile2[icq]', interests='$member_profile2[info]' where id='$member_idprof2'");
		$db->query("UPDATE ibf_members set email='$member_profile2[email]' where id='$member_idprof2'");
		$db->query("UPDATE ibf_members_converge set converge_email='$member_profile2[email]' where converge_id='$member_idprof2'");

		$db->connect(DBUSER, DBPASS, DBNAME, DBHOST);
	}


	/*     */
    function generate_password_salt($len=5)
	{
		$salt = '';
		
		//srand( (double)microtime() * 1000000 );
		// PHP 4.3 is now required ^ not needed
		
		for ( $i = 0; $i < $len; $i++ )
		{
			$num   = rand(33, 126);
			
			if ( $num == '92' )
			{
				$num = 93;
			}
			
			$salt .= chr( $num );
		}
		
		return $salt;
	}


	/*    */

	function generate_compiled_passhash($salt, $md5_once_password)
	{
		return md5( md5( $salt ) . $md5_once_password );
	}

	/*  -  */
		function generate_auto_log_in_key($len=60)
	{
		$pass = $this->generate_password_salt( 60 );
		
		return md5($pass);
	}


	function user_ip()
	{
		if (getenv("HTTP_CLIENT_IP")) $ip = getenv("HTTP_CLIENT_IP");
		else if(getenv("HTTP_X_FORWARDED_FOR")) $ip = getenv("HTTP_X_FORWARDED_FOR");
		else if(getenv("REMOTE_ADDR")) $ip = getenv("REMOTE_ADDR");
		else $ip = "not detected";
		return $ip;
	}

	function user_agent() {
		return getenv("HTTP_USER_AGENT");
	}

}

?>